/* ******************************************************************* */
/*          PROGRAMA PARA LA INICIALIZACION DE PESOS                   */
/*          DE FORMA ALEAORIA ENTRE -1 y 1									  */
/* ******************************************************************* */

/* Includes */
#include <stdio.h>
#include <stdlib.h>


/* Variables globales */

long nInputNodes,
     nHiddenNodes,
     nOutputNodes;



void main(int argc, char *argv[])

{

	long H,I,J;      /* Indice de las capas */
	FILE *pesos;     /* Fichero de salida con los pesos aletatorios */
	double W;        /* Pesos */

	if (argc != 2)  /* No es vlida la linea de comandos */
		{
		printf("\n\nAYUDA: PESOS fichero_peso");
		printf("\n       donde: fichero_peso -> Es el fichero de salida que contentr los pesos.\n\n");
		exit(1);
		}

	clrscr();
	printf("\n**************************** Generar Pesos Aletorios **************************");
	printf("\n\n N de unidades en la capa de entrada = ");
	scanf("%ld", &nInputNodes);
	printf(" N de unidades en la capa oculta     = ");
	scanf("%ld", &nHiddenNodes);
	printf(" N de unidades en la capa de salida  = ");
	scanf("%ld", &nOutputNodes);
	if ((pesos = fopen(argv[1],"w")) == NULL) /* lo creamos de escritura */
		{
		printf("\n\n ERROR: El fichero %s no se pudo crear\n\n", argv[1]);
		exit(1);
		}

	randomize();
	for (H = 0;H< nHiddenNodes;H++)
		for (I=0;I<=nInputNodes;I++)
			{
			W = (random(200) - 100) / 100.0;  /* numeros entre -1 y 1 */
			printf(" Peso generado: %.3lf\r",W);
			fprintf(pesos,"%lf\n",W);
			}
	for (J = 0;J< nOutputNodes;J++)
		for (H=0;H<=nHiddenNodes;H++)
			{
			W = (random(200) - 100) / 100.0;  /* numeros entre -1 y 1 */
			printf(" Peso generedo: %.3lf\r",W);
			fprintf(pesos,"%f\n",W);
			}
	fclose(pesos);
	printf("\n\n  El fichero %s se ha generado correctamente !!", argv[1]);
}